// bank.cpp: implementation of the bank class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "bank.h"
#include "account.h"
#include "trans.h"
#include <iostream>
#include <fstream>
using namespace std;

// open files and read bank info
bank::bank(char * cust, char * transfile)
{
    ifstream c,t;  //customer and transaction file objects
    int acc;
    string name;
    char type;
    float value;
    account *a;
    trans *b;

    accountfile = strdup(cust);
    cout << "opening customer file " << cust << endl;
    c.open(cust);
    if(!c)  // open of customer file failed
        throw "file open customer failed";

    cout << "opening transaction file " << transfile << endl;
    t.open(transfile);
    if(!c)  // open of trans file failed
        throw "file open trans failed";

    // read in the data from the accounts file and create a
    // new account object to add to the account list
    while(c) {
        c >> acc >> name >> value;
        if(c.eof()) break; // to avoid duplicate last entry
        if( (a = new account(name,acc,value)) == NULL)
            throw "no memory for account";
        customers.push_back(*a); // add to list
    } // while c
    c.close();

    // read in the data from the transaction file and create a
    // new transaction object to add to the transaction list
    while(!t.eof()) {
        t >> acc >> type >> value;
        if(t.eof()) break; // to avoid duplicate last entry
        if( (b = new trans(type,acc,value)) == NULL)
            throw "no memory for trans";
        cout << "Adding trans:" << *b << endl;
        transactions.push_back(*b); // add to list
    } // while t
    t.close();
} // bank

// walk the transaction list and post events
void
bank::process_trans()
{
    list<trans>::iterator tptr;
    list<account>::iterator bptr;
    cout << "There are " << transactions.size() << " transactions to process" << endl;
    // for each transaction
    for(tptr = transactions.begin(); tptr != transactions.end(); tptr++) { 
        cout << "doing: " << *tptr << endl;
        // first find the account record
        for(bptr = customers.begin(); bptr != customers.end(); bptr++) { 
            if(bptr->get_accountnum() == tptr->get_account()) { // found it
                bptr->post(tptr->get_type(),tptr->get_amount()); // update it
                break; // no need to look at more accounts for this transaction
            }
        } // inner for
    } // outer for
} // process_trans

// show all the customer accounts
void
bank::show_accounts()
{
    list<account>::iterator ptr;
    cout << "Current accounts are: " << endl;
    for(ptr = customers.begin(); ptr != customers.end(); ptr++) { 
        cout << *ptr;
    }
} // shoe_accounts

// update the accounts file
void
bank::update_accounts()
{
    ofstream c;  //customer objects
    list<account>::iterator ptr;

    cout << "opening customer file " << accountfile << endl;
    c.open(accountfile);
    if(!c)  // open of customer file failed
        throw "file open customer failed";

    // write data to the accounts file 
    for(ptr = customers.begin(); ptr != customers.end(); ptr++) { 
        c << ptr->get_accountnum() << "\t" << 
             ptr->get_name() << "\t" << ptr->get_balance() << endl;
    } // while customers
    c.close();
} // update_accounts
