**// lab2d.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdlib.h>
#include <iostream.h>
#include <string.h>

const char * TESTVOWELS = "This string has some vowels in it";
const char * TESTNOVOWELS = "qwtypfg";
const char * VOWELS = "aeiou";  // traditional vowels

// print the passed in string one letter at a time
void
print(const char * str)
{
	if(str == NULL) return;
	while(*str)
		cout << *str++;
	cout << endl;
} // print

// print the passed in string one letter at a time
// a variation using for loops
void
print2(const char * str)
{
	if(str == NULL) return;
	for( ; *str; str++)
		cout << *str;
	cout << endl;
} // print2

// print the passed in string one letter at a time
// another variation using for loops
void
print3(const char * str)
{
	if(str == NULL) return;
	for( ; *str; cout << *str++) ;
	cout << endl;
} // print3

// -------------------  vowel finders --------------------
// all versions of this routine use the tolower() macro to convert each character
// to lowercase before the comparisson

// search the string str and copy all the vowels into a new string
// return the string of vowels.
// If there are no vowels, throw an exception
// This one uses a big if statement
char *
find_vowels(const char * str)
{
	char * vstr, *vptr;
	if((vstr = new char[strlen(str)+1]) == NULL) throw "No Memory";
	vptr=vstr;

	while(*str) {
		if( tolower(*str) == 'a' ||
		    tolower(*str) == 'e' ||
		    tolower(*str) == 'i' ||
		    tolower(*str) == 'o' ||
		    tolower(*str) == 'u' )
			*vstr++ = *str; // store the vowel in the new string
		str++;  // on to the next character
	}

	*vstr = '\0';  // mark the end of the vowel string
	// if there were no vowels then the first character in the new vowel
	// string would be '\0'. If *vptr (which points to the beginning
	// of the string) is '\0',  then it is false.
	// By putting a ! in front of it, we reverse that logic and so
	// if the first character in the vowel string is '\0' meaning there
	// were no vowels, then
	// the expression in the if is true and we throw the exception.
	if(!*vptr) throw "No vowels found";
	return(vptr); // the pointer to the front of the string
} // find_vowels

// search the string str and copy all the vowels into a new string
// return the string of vowels.
// If there are no vowels, throw an exception
// This one uses a switch statement
char *
find_vowels2(const char * str)
{
	char * vstr, *vptr;
	if((vstr = new char[strlen(str)+1]) == NULL) throw "No Memory";
	vptr=vstr;

	while(*str) {
		switch(tolower(*str)) {
			case 'a' :
			case 'e' :
			case 'i' :
			case 'o' :
			case 'u' :
				*vstr++ = *str; // store the vowel in the new string
				break;
		} // esac
		str++;  // on to the next character
	}

	*vstr = '\0';  // mark the end of the vowel string
	// if there were no vowels then the first character in the new vowel
	// string would be '\0'. If *vptr (which points to the beginning
	// of the string) is '\0',  then it is false.
	// By putting a ! in front of it, we reverse that logic and so
	// if the first character in the vowel string is '\0' meaning there
	// were no vowels, then
	// the expression in the if is true and we throw the exception.
	if(!*vptr) throw "No vowels found";
	return(vptr); // the pointer to the front of the string
} // find_vowels2
//
// search the string str and copy all the vowels into a new string
// return the string of vowels.
// If there are no vowels, throw an exception
// This one uses an inner loop
char *
find_vowels3(const char * str)
{
	char * vstr, *vptr;
	if((vstr = new char[strlen(str)+1]) == NULL) throw "No Memory";
	vptr=vstr;

	while(*str) {
		for(int i = 0; VOWELS[i]; i++) {
			if(tolower(*str) == VOWELS[i]) {
			   *vstr++ = *str; // store the vowel in the new string
			   break;
			} // inner if
		} // inner while
		str++;  // on to the next character
	}

	*vstr = '\0';  // mark the end of the vowel string
	// if there were no vowels then the first character in the new vowel
	// string would be '\0'. If *vptr (which points to the beginning
	// of the string) is '\0',  then it is false.
	// By putting a ! in front of it, we reverse that logic and so
	// if the first character in the vowel string is '\0' meaning there
	// were no vowels, then
	// the expression in the if is true and we throw the exception.
	if(!*vptr) throw "No vowels found";
	return(vptr); // the pointer to the front of the string
} // find_vowels3

int main(int argc, char* argv[])
{
	cout << "Print the test string using print()" << endl << "\t";
	print(TESTVOWELS);

	cout << "Print the test string using print2()" << endl << "\t";
	print2(TESTVOWELS);
	
	cout << "Print the test string using print3()" << endl << "\t";
	print3(TESTVOWELS);

	try {
		cout << "find_vowels() with TESTVOWELS" << endl << "\t";
		print(find_vowels(TESTVOWELS));

		cout << "find_vowels2() with TESTVOWELS" << endl << "\t";
		print(find_vowels2(TESTVOWELS));

		cout << "find_vowels3() with TESTVOWELS" << endl << "\t";
		print(find_vowels3(TESTVOWELS));

		cout << "TESTNOVOWELS" << endl << "\t";
		print(TESTNOVOWELS);
		cout << "find_vowels() with TESTNOVOWELS" << endl << "\t";
		print(find_vowels(TESTNOVOWELS));
	} catch(char * s) {
		cerr << "Exception: " << s << endl;
	  }
	catch(...) {
		cerr << "Unexpected Exception: " << endl;
	  }
	return 0;
}
