// arrptr.cpp : Example of array and pointers
//

#include "stdafx.h"
#include <iostream.h>

const int MAX=6;


int main(int argc, char* argv[])
{
	int array[MAX];  // standard static array, size fixed at compile time
	int * ptr;       // integer pointer, can point to several arrays
	int i;  // loop index

	// first put numbers into the array and then print them
	for(i = 0; i < MAX; i++)
		array[i]=i;
	for(i = 0; i< MAX; i++)
		cout << "array[" << i << "] = " << array[i] << endl;

	// get memory for a new array and point ptr at it
	ptr = new int[MAX];
	// check that we got the memory we asked for
	if(ptr == NULL) {
		cerr << "Memory failed" << endl;
		return(1);
	}
	// now load it up and print it
	for(i = 0; i < MAX; i++)
		ptr[i]=i*2+MAX;
	for(i = 0; i< MAX; i++)
		cout << "ptr[" << i << "] = " << ptr[i] << endl;

	//here we are showing the relationship between pointers and arrays
	
	// the name of an array is a pointer to the array
	cout << "array[0] is " << array[0] << " == *array == " << *array << endl;
	
	// a pointer to the array is the name of an array
	cout << "ptr[0] is " << ptr[0] << " == *ptr == " << *ptr << endl;


	// pointer arithmetic
	cout << "ptr = " << ptr << endl;
	cout << "ptr+1 = " << ptr+1 << endl;
	cout << "ptr+2 = " << ptr+2 << endl;

	cout << "array = " << array << endl;
	cout << "array+1 = " << array+1 << endl;
	cout << "array+2 = " << array+2 << endl;
	
	// pointer arithmetic and array notation
	cout << "*ptr = " << *ptr << endl;
	cout << "ptr[0] = " << ptr[0] << endl;
	cout << "*(ptr+1) = " << *(ptr+1) << endl;
	cout << "ptr[1] = " << ptr[1] << endl;

	cout << "*(ptr+2) = " << *(ptr+2) << endl;
	cout << "*ptr+2 = " << *ptr+2 << endl;
	return 0;
}
