// alists.cpp example code for array based lists

#include "stdafx.h"
#include "alists.h"
#include <iostream.h>


struct List_data List[SIZE];

int Pos = 0; // last place used in table

// set all slots to free
void
init()
{
	for(int i = 0; i < SIZE; i++)
		List[i].next = FREE;
} // init

// find and empty slot in the array
// and return it
int
find_empty()
{
	int start = Pos; // start where we left off
	while(List[start].next != FREE) {
		start  += ++start % SIZE;  // wrap around the array
		if(start == Pos) return NIL;  // we wrapped around
	} // while
	// the only way out of the loop this way is if
	// we found one
	Pos = (start+1) % SIZE; // start again after the one we found
	return start;
} // find_empty

int
find_empty2()
{
	for(int start = Pos+1; start != Pos; start += ++start % SIZE) {
		if(List[start].next != FREE) {
			Pos = start;
			return start;
		}
	} // for
	return NIL; // if we get here, we wrapped around
} // find_empty2

// add an element to the end of the array
int
add_element(int& l, Data my_d)
{
	int lptr = l;
	int my_l = find_empty(); // find a place for it
	if(my_l == NIL) return -1;  // no memory
	List[my_l].d = my_d;
	List[my_l].next = NIL;
	// find the end of the list
	while( (lptr != NIL) && (List[lptr].next != NIL)) {
		lptr = List[lptr].next;
	} // while
	if(lptr == NIL) 
		l = my_l; // first entry
	else
		List[lptr].next = my_l;
	return 0;	
} // add_element

// print the entire array
void
print()
{
	for(int i = 0; i < SIZE; i++)
		cout << List[i].d.f << " next = " << List[i].next << endl;
} // print

// print the given list
void
print_list(int l)
{
		int lptr = l;
		if(lptr == NIL) return;
		while(lptr != NIL) {
			cout << List[lptr].d.f << endl;
			lptr = List[lptr].next;
		} // while
} // print_list

void
main(int argc, char *argv[])
{
	Data my_d;
	int list1=NIL,list2=NIL;

	init();
	cout << "after init\n";
	print();

	for(int i=0; i< 3; i++) {
		my_d.f = 3.14159 * i;	
		if(add_element(list1,my_d) == -1)
			cout << "add_element failed\n";
	}// for
	cout << "print list 1\n";
	print_list(list1);
	cout << "after list1 add\n";
	print();
} //main