// str4.cpp : demonstrates several ways to copt a character array string.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>

const int STRLEN= 50;

char *
forloop1(char * src)
{
   char *copy;
   if( (copy = new char[strlen(src) + 1]) == NULL) {
   	cerr << "No memory for string" << endl;
   	return NULL;
   }
   for(int i=0; i < strlen(src)+1; i++)
      copy[i] = src[i];
   return copy;
} // forloop1

char *
forloop2(char * src)
{
   char *copy;
   if( (copy = new char[strlen(src) + 1]) == NULL) {
   	cerr << "No memory for string" << endl;
   	return NULL;
   }
   for(int i=0; src[i] != '\0'; i++)
      copy[i] = src[i];
   copy[i] = '\0';
   return copy;
} // forloop2

/* here is another way to do this, provided by Doug.
   it doesn't require the copy pointers since it doesn't alter
   the originals. Thus it uses somewhat less space.
   Plus there is no chance of accidentally altering the original
*/
char *
forloop3(char * src)
{
   char *copy;
   if( (copy = new char[strlen(src) + 1]) == NULL) {
   	cerr << "No memory for string" << endl;
   	return NULL;
   }
   for(  int x=0; (*(copy+x) = *(src+x)) != '\0'; x++) ;
   return copy;
} // forloop3

char *
forloop4(char * src)
{
   char *copy;
   if( (copy = new char[strlen(src) + 1]) == NULL) {
   	cerr << "No memory for string" << endl;
   	return NULL;
   }
   for(  int y=0; (copy[y] = src[y]) != '\0'; y++) ;
   return copy;
} // forloop4

char *
hardest(char * src)
{
   char *copy,*dest;
   if( (copy = new char[strlen(src) + 1]) == NULL) {
   	cerr << "No memory for string" << endl;
   	return NULL;
   }
   dest=copy; 
   while(*dest++ = *src++) ; // all the work is in here
   return copy;
} // hardest

char *
hardest2(char * src)
{
   char *copy,*dest;
   if( (copy = new char[strlen(src) + 1]) == NULL) {
   	cerr << "No memory for string" << endl;
   	return NULL;
   }
   printf("Dest start value is [%d] src start address is [%d]\n",copy,src);
   while(*copy++ = *src++) {
      printf("copied src[%d](%c) to dest[%d](%c)\n",src-1,*(src-1),copy-1,*(copy-1));
   }
   return copy;
} // hardest2

void 
main(int argc, char **argv)
{
   char instr[STRLEN],*ptr,*copy,*src,*dest;

   (void) strcpy(instr,"forloop1");
   cout << "the input string was :" << instr << ":" << endl;
   cout << "copy using forloop1 :" << forloop1(instr) << ":" << endl;

   (void) strcpy(instr,"forloop2");
   cout << "the input string was :" << instr << ":" << endl;
   cout << "copy using forloop2 :" << forloop2(instr) << ":" << endl;

   (void) strcpy(instr,"forloop3");
   cout << "the input string was :" << instr << ":" << endl;
   cout << "copy using forloop3 :" << forloop3(instr) << ":" << endl;

   (void) strcpy(instr,"forloop4");
   cout << "the input string was :" << instr << ":" << endl;
   cout << "copy using forloop4 :" << forloop4(instr) << ":" << endl;

   (void) strcpy(instr,"hardest");
   cout << "the input string was :" << instr << ":" << endl;
   cout << "copy using hardest :" << hardest(instr) << ":" << endl;

   // do it again, showing the steps
   (void) strcpy(instr,"hardest2");
   cout << "the input string was :" << instr << ":" << endl;
   cout << "copy using hardest2 :" << hardest2(instr) << ":" << endl;

   /* pointer loop printing */
   cout << "pointer loop printing" << endl;
   (void) strcpy(instr,"print test");
   ptr=instr;
   while(*ptr) putchar(*ptr++);
   putchar('\n');

} // main
