// inherit3.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream.h>
#include <stdlib.h>
#include <string.h>

class foo {
    public:    // first we do all  the public interface methods
    // these are used to put values in the private data elements
    void set_a(int x) { a=x;}
    void set_b(int x) { b=x;}

    // these are used to get the values from the private data elements
    int get_a() { return(a);}
    int get_b() { return(b);}
    int bigger(); 

    // these are the constructors
    foo() { a = 0; b = 0;}   // default constructor
    foo(int x) { a=x; b = 0;}
    foo(int x,int y) { a= x; b = y;}

    // these are protected data, not visible outside the class
    // but visible to child classes
    protected:  
    int a,b;
}; // class foo

int
foo::bigger()
{
   if(a < b) return(b);
   return(a);
} // foo::bigger

// class bar inherits from foo, so we only need to specify the things
// that are unique to bar
class bar : public foo {
   public:
    void set_c(int x) { c=x;}
    int get_c() { return(c);}
    int bigger(); // same name as one in foo

    // these are the constructors
    bar() {c = 0;}
    bar(int x) {c=x;}
    // a and b, although inherited by bar, are still private to foo
    bar(int x,int y, int z) { set_a(x); set_b(y); c = z;}
    void print_protected() { printf("a = %d b = %d c = %d\n",a,b,c);}
   private:
   int c;
}; // class bar

int
bar::bigger()
{
   if(get_a() < c) return(c);
   return(get_a());
} // bar::bigger

int 
main(int argc, char **argv)
{
   foo X,Y(6),Z(7,8);
   bar A,B(9),C(1,2,3);

   printf("X.a = %d X.b = %d\n",X.get_a(),X.get_b());
   printf("Y.a = %d Y.b = %d\n",Y.get_a(),Y.get_b());
   printf("Z.a = %d Z.b = %d\n",Z.get_a(),Z.get_b());
   printf("----------------------------------------\n");

   printf("A.a = %d A.b = %d A.c = %d\n",A.get_a(),A.get_b(),A.get_c());
   printf("B.a = %d B.b = %d B.c = %d\n",B.get_a(),B.get_b(),B.get_c());
   printf("C.a = %d C.b = %d C.c = %d\n",C.get_a(),C.get_b(),C.get_c());
   printf("----------------------------------------\n");

   printf("Child using parent variables directly\n");
   // This causes an error since I still can't access the data from outside
   // printf("C.a = %d C.b = %d C.c = %d\n",C.a,C.b,C.c);
   printf("----------------------------------------\n");
   printf("Child method accesses parent variables using child method\n");
   C.print_protected();
   printf("----------------------------------------\n");

// now lets play with bigger()
   printf("C.bigger = %d \n",C.bigger());
   printf("Z.bigger = %d \n",Z.bigger());
   printf("C.foo::bigger = %d \n",C.foo::bigger());
   return 0;

/* here is what I get when I run this with VC++
X.a = 0 X.b = 0
Y.a = 6 Y.b = 0
Z.a = 7 Z.b = 8
----------------------------------------
A.a = 0 A.b = 0 A.c = 0
B.a = 0 B.b = 0 B.c = 9
C.a = 1 C.b = 2 C.c = 3
----------------------------------------
Child using parent variables directly
----------------------------------------
Child method accesses parent variables using child method
a = 1 b = 2 c = 3
----------------------------------------
C.bigger = 3
Z.bigger = 8
C.foo::bigger = 2
Press any key to continue
*/
 
} // main
