// lab3d.cpp : create a list of holding records

#include "stdafx.h"
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

const int MAXTHINGS=30;
const int STRLENGTH=64;

class nomem {
   public:
      char * get_type() { return(type);}
      nomem() {type[0]='\0';}
      nomem(char * str) {(void) strcpy(type,str);}
   private:
      char type[STRLENGTH];
};

// parent class of books and videos
class holding {
public:
   // these functions are used to get the data from the class
   int    get_location() { return(location);}
   float  get_cost()  { return(cost);}
   char * get_name() { return(name);}

   // these functions are used to store the data into the class
   void  set_location(int c) { location = c;}
   void  set_cost(float f)  { cost = f;}
   void  set_name(char *);
   
   // virtual methods for the other classes
   virtual void printme();  // print this record
   virtual void loadme();   // get input from the user

   holding() { location=0; cost = 0; name = NULL;}
   ~holding() {if(name != NULL) delete [] name;}
private:
    char *name;  // name of the object
    int location; // where is it stored
    float cost;  // what did we pay for it
}; // holding

void
holding::set_name(char * str)
{
   if((name = new char [strlen(str)+1]) == NULL) {
      throw new nomem("holding::name");
      return;
   }
   (void) strcpy(name,str);
} // set_name

// print the fields from the parent class
void 
holding::printme()
{
   cout << "Name: " << name << endl;
   cout << "Cost: " << cost << endl;
   cout << "Location: " << location << endl;
} // holding::printme

// get the data from the user for the parent class
void 
holding::loadme()
{
   char str[STRLENGTH];

   cout << "Enter Name: ";
   cin >> str; 
   name = strdup(str);

   cout << "Enter Cost: "; cin >> cost; 
   cout << "Enter Location: "; cin >> location; 
} // holding::loadme

// this class represents a book and inherits from holding
class book : public holding {
public:
   // these functions are used to get the data from the class
   int    get_pages() { return(pages);}
   char * get_author() { return(author);}

   // these functions are used to store the data into the class
   void  set_pages(int p) { pages = p;}
   void  set_author(char *);

   void printme();  // print this record
   void loadme();   // get input from the user

   book() { pages=0; author = NULL;}
   ~book() {if(author != NULL) delete [] author;}
private:
    char *author; // who wrote the book
    int pages; // how long is it
}; // book

void
book::set_author(char * str)
{
   if((author = new char [strlen(str)+1]) == NULL) {
      throw new nomem("book::author");
      return;
   }
   (void) strcpy(author,str);
} // set_author

void 
book::printme()
{
   holding::printme(); // print the parent stuff first
   cout << "Author: " << author << endl;
   cout << "Pages: " << pages << endl;
} // book::printme

// get data from user for the book
void 
book::loadme()
{
   char str[STRLENGTH];

   holding::loadme(); // get the parent stuff first
   cout << "Enter Author: ";
   cin >> str;
   author = strdup(str);

   cout << "Enter Pages: "; cin >> pages; 
} // book::loadme

// holds the video data
class video : public holding {
public:
   // these functions are used to get the data from the class
   int    get_length() { return(length);}
   char * get_director() { return(director);}

   // these functions are used to store the data into the class
   void  set_length(int p) { length = p;}
   void  set_director(char *);

   void printme();  // print this record
   void loadme();   // get input from the user

   video() { length=0; director = NULL;}
   ~video() {if(director != NULL) delete [] director;}
private:
    char *director; // who directed it?
    int length; // how many minutes?
}; // video

void
video::set_director(char * str)
{
   if((director = new char [strlen(str)+1]) == NULL) {
      throw new nomem("video::director");
      return;
   }
   (void) strcpy(director,str);
} // set_director

// print the video info
void 
video::printme()
{
   holding::printme(); // print the parent info first
   cout << "Director: " << director << endl;
   cout << "Length: " << length << endl;
} // video::printme

// get the video info from the user
void 
video::loadme()
{
   char str[STRLENGTH];

   holding::loadme(); // get parent data first
   cout << "Enter Director: ";
   cin >> str;
   director = strdup(str);

   cout << "Enter Length: "; cin >> length; 
} // video::loadme

int 
main(int argc, char* argv[])
{
    holding * Library[MAXTHINGS];  // array of holding pointers
    int actual_count = 0;
    char yn='y',type;
    bool done = false;

    try {
       while((!done) && (actual_count < MAXTHINGS)) {
          cout << "Do you want to make a b)ook or v)ideo or q)uit? (b,v,q): ";
          cin >> type; 
          switch(tolower(type)) {
             case 'b' :
                if((Library[actual_count] = new book) == 0) throw new nomem("book");
	     break;
	     case 'v':
                if((Library[actual_count] = new video) == 0) throw new nomem("video");
	     break;
	     case 'q':
	     	done = true;
          } // esac
   
	  if(done) break; 
	  // since loadme() is virtual, run the appropriate method
	  // from the object this actually points to
          Library[actual_count]->loadme();
          actual_count++;
       } // while
    } catch(nomem m) {
       cout << "no memory for data item " << m.get_type() << endl;
       exit(-1);
    }

    cout << "list of holdings" << endl;
    for(int i = 0; i < actual_count; i++) {
      Library[i]->printme();
      cout << endl;
    }

    return 0;
} // main
