// lab5d.cpp : read a sentence from a file into a list and 
// reverse the list into a second list.

#include "stdafx.h"
#include <iostream>
#include <fstream>
#include <list>
#include <string>
using namespace std;

void
print_list(list<string> l)
{
    list<string>::iterator ptr = l.begin();
    // run as a do loop and check for end inside to avoid
    // printing a trailing ->
    do {
        cout << *ptr;
        ptr++;
        if(ptr != l.end()) cout << "->";
    } while(ptr != l.end());
    cout << endl;
} // print_list

int
count_chars(list<string> l)
{
    list<string>::iterator ptr;
    int count = 0;
    for(ptr = l.begin(); ptr != l.end(); ptr++)
        count += ptr->length();
    return count;
} // count_chars

// this takes two lists and checks that they
// contain the same strings in reverse order
// This works by starting the second iterator at the
// end() and decrementing it. Since the end() is one
// past the last element, we have to decrement it before we start.
// The first section of the for loop is run once before the
// loop starts, so it is a good place to do this.
// We don't have to do anything to ptr1 there since
// we initialize it when we defined it.
// This is NOT a reverse iterator, see check_reverse2()
// for that.
bool
check_reverse(list<string> one, list<string>two)
{
    list<string>::iterator ptr1 = one.begin();
    list<string>::iterator ptr2 = two.end();
    //
    // if the lengths don't match, give up
    if(one.size() != two.size()) return false;
    for(ptr2--; ptr1 != one.end(); ptr1++,ptr2--) {
        if(*ptr1 != *ptr2) return false;
    }
    return true;
} // check_reverse

// reverse iterators start at rbegin() which points to the last
// element in the list and when incremented, go backwards towards
// rend();
bool
check_reverse2(list<string> one, list<string>two)
{
    list<string>::iterator ptr1;
    list<string>::reverse_iterator ptr2;

    // if the lengths don't match, give up
    if(one.size() != two.size()) return false;
    for(ptr1=one.begin(),ptr2=two.rbegin(); ptr1 != one.end(); ptr1++,ptr2++) {
        if(*ptr1 != *ptr2) return false;
    }
    return true;
} // check_reverse2

int 
main(int argc, char* argv[])
{
    ifstream dfile("lab5.txt");
    list<string> orig;  // the original list of words
    list<string> reverse; // the reversed list
    string str;

    if(!dfile) {
        cerr << "couldn't open the data file" << endl;
        return 1;
    }
    while(true) {
        dfile >> str;
        if(dfile.eof()) break;  // end of file
        orig.push_back(str);
    } // data file read loop

    // print the original list
    cout << "the original sentence is \t" << endl;
    print_list(orig);

    // now reverse into a new list
    // the techniques is to use push_front().
    // This puts each word in front of the last one
    list<string>::iterator ptr;
    for(ptr = orig.begin(); ptr != orig.end(); ptr++)
        reverse.push_front(*ptr);
    cout << "the reversed sentence is \t" << endl;
    print_list(reverse);

    cout << count_chars(orig)  << " characters are in the list" << endl;

    cout << "trying the orig and reverse lists" << endl;
    cout << "they are ";
    if(!check_reverse(orig,reverse)) cout << " NOT ";
    cout << "reverses of each other" << endl;

    cout << "trying the orig and orig lists" << endl;
    cout << "they are ";
    if(!check_reverse(orig,orig)) cout << " NOT ";
    cout << "reverses of each other" << endl;

    cout << "check_reverse2: trying the orig and reverse lists" << endl;
    cout << "they are ";
    if(!check_reverse2(orig,reverse)) cout << " NOT ";
    cout << "reverses of each other" << endl;

    return 0;
}
