// stllist.cpp : linked list big number using STL lists

#include "stdafx.h"
#include <iostream>
#include <string.h>
#include <list>

using namespace std;

class digit {
public:
   digit() : value(0) {};  // constructor
   digit(int j) : value(j) {};  // constructor
   int get_digit(void) { return(value);};
   void set_digit(const int num) { value=num; };
   friend ostream & operator<<(ostream & os, digit & d) { return os << d.value; };
private:
   int value;
};
// -----------------------------------------------------------------------------

class bignum {
public:
   bignum(void) : L() {};  // constructor
   bignum(char *str) {this->read_string(str);};  // constructor
   ~bignum(void) {L.~list();}; // destructor
   list<digit> get_L() { return L;};
   int how_big() { return(L.size());};
   int is_empty() { return(L.size() == 0);};
   void add_digit(int n) { digit *a=new digit(n); L.push_front(*a);};
   void read_string(char * str);
   friend ostream& operator<<(const ostream& os, bignum& num);
   friend bignum * operator+(bignum & left,bignum & right);
   void push_digit(int n) { digit *a=new digit(n); L.push_back(*a);};
private:
   list<digit> L;
};

void
bignum::read_string(char * str)
{
   digit *phalange;
   for(int i=0;i<strlen(str);i++) {
      if( (phalange = new digit(str[i]-'0')) == NULL) return;
      L.push_front(*phalange);
   } // for
} // read_string 

// walk the bignum, printing each nodes digit 
ostream & 
operator<<(ostream& os, bignum& num)
{
     list<digit>::iterator ptr = num.get_L().end();
     while(true) {
         --ptr;
         os << (*ptr).get_digit();
         if(ptr == num.get_L().begin()) break;
     } // while
   return os << endl;
} // operator<<

bignum *
operator+(bignum& left,bignum& right) 
{
   int carry=0,one,two,three;
   list<digit>::iterator  me ,nptr;
   bignum *result=new bignum;

   nptr=right.get_L().begin(); me=left.get_L().begin();

   for(;;) {
      one = (nptr != right.get_L().end()) ? (*nptr).get_digit() : -1;
      two = (me != left.get_L().end()) ? (*me).get_digit() : -1;
      if((one == -1) && (two == -1)) { // both done
         if(carry > 0)
            result->push_digit(carry);
         return result;
      }
      three = one + two + carry;
     
      if(one == -1)  // copy rest of two
            three = two + carry;
      if(two == -1)  // copy rest of one
            three = one + carry;

      if(three >=  10) {
        carry=1;
        three -= 10;
      }
      result->push_digit(three);
      if(me != left.get_L().end()) me++; 
      if(nptr != right.get_L().end()) nptr++;
   } // for
} // operator+
// -----------------------------------------------------------------------------

int 
main(int argc, char* argv[])
{
   bignum one,two,*three;
   char d[3];

   if(argc < 3) { // not enough args
      (void) fprintf(stderr,"usage %s: first_number second_number\n",argv[0]);
      exit(1);
   }
   one.read_string(argv[1]); two.read_string(argv[2]);

   cout << "bignum one has " << one.how_big() << " elements" << endl << one;

   cout << "bignum two has " << two.how_big() << " elements" << endl << two;

   three=one + two; //two.add(one);
   cout << "here is the final bignum three" << endl << *three;

	return 0;
}
