/* tree.h - Class that represents a binary tree
 * Binary trees have at most two children per node
 * Includes a node structure.
 * */

#include <stdlib.h>

enum PRINT_TYPE{INORDER,POSTORDER,PREORDER};

class tree {
    public:
        tree() { root=NULL; debug=false;}
//        ~tree();
        bool add_value(char *);    // add a new string value to the tree
        bool find(char *);         // search for a string, return true or false
        void print(enum PRINT_TYPE t);  // print the tree, inorder, postorder or preorder
        void treeprint();  // print the tree sideways
        bool remove(char *);       // search for the string and delete the node
        bool remove2(char *);      // alt search for the string and delete the node
	void inserti(char *);  // iterative insert
        void debugon() { debug = true;}
        void debugoff() { debug = false;}
    private:
        struct node {
            char * value;
            node * left;
            node * right;
        };
        node * root;
        bool debug;
        bool add_valuer(node * & ,char * );
        void printr(node *,enum PRINT_TYPE );
        void treeprintr(node *, int); 
        bool findr(node *, char *); 
        bool remover(char *,node *&);
        void del(node *&, node *);  // support function for remover2
        bool remover2(char *,node *&);
        void del2(node *&, node *);  // support function for remover2
	void insert2(node * &,char *);
}; // tree
