// trees.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include "tree.h"
#include "except.h"

int main(int argc, char* argv[])
{
    tree T;
    char str[32];
    T.debugon();
    ifstream filein;

    filein.open("trees.txt");   // file to read test strings from

    if( ! filein) {
        cout << "Couldn't open the test data file" << endl;
        exit(1);
    }

    try {
        while(! filein.eof()) {
            filein >> str;
            T.add_value(str);
            cout << "After adding <" << str << ">" << endl;
        } // input file read
        filein.close();
    }
    catch(Err *e) {
        cout << "ERROR:" << *e << endl;
    }
    catch(Mem *m) {
        cout << "MEMORY:" << *m << endl;
    }
    // in order print
    T.print(INORDER);
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    // print the tree sideways
    T.treeprint();
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    // search for the word 'data'
    if(T.find("color"))
        cout << "Word (color) was found" << endl;
    else
        cout << "Word (color) was not found" << endl;
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    // search for the word 'kent'
    if(T.find("kent"))
        cout << "Word (kent) was found" << endl;
    else
        cout << "Word (kent) was not found" << endl;

    try {
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    // search for the word ''
    if(T.find(""))
        cout << "Word () was found" << endl;
    else
        cout << "Word () was not found" << endl;
    }
    catch(Err *e) {
        cout << "ERROR:" << *e << endl;
    }
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    // delete the word dog
    if(T.remove("dog"))
        cout << "Word (dog) was deleted" << endl;
    else
        cout << "Word (dog) was not deleted" << endl;
    T.treeprint();
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    // add back  the word dog
    T.inserti("dog");
    T.treeprint();
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();
    //
    // delete the word cut using the alternate remove
    if(T.remove2("cut"))
        cout << "Word (dog) was deleted" << endl;
    else
        cout << "Word (cut) was not deleted" << endl;
    T.treeprint();
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();
    //
    // add back the word dog
    T.inserti("cut");
    T.treeprint();
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    cout << "In order print" << endl;
    T.print(INORDER);
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    cout << "pre order print" << endl;
    T.print(PREORDER);
    cout << "-------------------------------------" << endl;
    cout << "hit something to continue";
    cin.ignore();

    cout << "post order print" << endl;
    T.print(POSTORDER);

    return 0;
}
