// trees.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <iostream.h>
#include <fstream.h>
#include "tree.h"
#include "except.h"
bool Debug;

int main(int argc, char* argv[])
{
    tree *T = NULL;
    char str[32];
    ifstream filein;
    ofstream fileout;

    filein.open("trees.txt");   // file to read test strings from
    fileout.open("treeso.txt");   // file to write results to

    if( ! filein) {
        cerr << "Couldn't open the test data file" << endl;
        exit(1);
    }
    if( ! fileout) {
        cerr << "Couldn't open the test data output file" << endl;
        exit(1);
    }

    Debug=false;
    try {
        while(filein) {
            filein >> str;
            add_value(T,str);
            fileout << "After adding <" << str << ">" << endl;
        } // input file read
        filein.close();
    }
    catch(Err *e) {
        fileout << "ERROR:" << *e << endl;
    }
    catch(Mem *m) {
        fileout << "MEMORY:" << *m << endl;
    }
    // in order print
    inprint(T,fileout);
    fileout << "-------------------------------------" << endl;

    // print the tree sideways
    treeprint(T,fileout);
    fileout << "-------------------------------------" << endl;

    // search for the word 'data'
    if(find(T,"data"))
        fileout << "Word (data) was found" << endl;
    else
        fileout << "Word (data) was not found" << endl;
    fileout << "-------------------------------------" << endl;

    // search for the word 'kent'
    if(find(T,"kent"))
        fileout << "Word (kent) was found" << endl;
    else
        fileout << "Word (kent) was not found" << endl;

    try {
    fileout << "-------------------------------------" << endl;

    // search for the word ''
    if(find(T,""))
        fileout << "Word () was found" << endl;
    else
        fileout << "Word () was not found" << endl;
    }
    catch(Err *e) {
        fileout << "ERROR:" << *e << endl;
    }
    fileout << "-------------------------------------" << endl;

    // delete the word data
    if(remove("data",T))
        fileout << "Word (data) was deleted" << endl;
    else
        fileout << "Word (data) was not deleted" << endl;
    postprint(T,fileout);
    fileout << "-------------------------------------" << endl;

    // add back  the word data
    inserti(T,"data");
    preprint(T,fileout);
    fileout.close();

    return 0;
}
