// code for the vector class
#include "stdafx.h"
#include "vector.h"
#include <iostream.h>

// create the initial vector of length DEFSIZE
vector::vector()
{
	length = DEFSIZE;
	count = 0;
	if( (vptr = new int[length]) == NULL) {
		cerr << "No memory for vector of length " << length << endl;
	}
} // constructor

// create the initial vector of length size
vector::vector(int size)
{
	length = size;
	count = 0;
	if( (vptr = new int[length]) == NULL) {
		cerr << "No memory for vector of length " << length << endl;
	}
} // 1 arg constructor

// print the current data elements in the vector
void
vector::print()
{
	for(int i = 0; i < count; i++)
		cout << "vector[" << i << "] = " << vptr[i]  << endl;
} // print

// adds the integer x to the next slot in the vector
// if the vector is full, it allocates a new array, copies the values,
// and adjusts the pointers
void
vector::add(int x)
{
	// count is the number of used slots
	// length is the number of slots
	if( count == length) {  // make new array
		cout << "making new array" << endl;
		int * tptr = new int[length + INCR];
		if(tptr == NULL) { // this is fatal
			cerr << "No memory for new array" << endl;
			exit(1);
		}
		for(int i=0; i < count; i++) tptr[i] = vptr[i];
//		delete vptr;  // we don't need this anymore
		vptr = tptr;  // make the new array the current array
		length += INCR;
	}
	vptr[count++] = x;
} // add
